Lua_CollectionBookCardDetailWindow = class("Lua_CollectionBookCardDetailWindow", Lua_Window);
function Lua_CollectionBookCardDetailWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_CollectionBookCardDetailWindow";
	self.skinName = "CollectionBookCardDetailWindow_skin";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;

	-- self.setImgPath = "/images/common/ui_common_window_016.png";
    -- self:addPreLoadRes(self.setImgPath, Lua_LoadFileType.IMG);
end

function Lua_CollectionBookCardDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.backBtn:setLocation(55, 54);
	self.shareObj:SetActive(false);

	-- 分享icon的背景
	self.shareBg.clickScale = false;
	self.shareBg.clickSound = nil;
	self.shareBg:addClickFuntion(self, self.onShareBgClick);

	self.flashItem = Lua_CommonFlashCardItem.new(self.content);
	self.flashItem:setRectAnchor(1);
	self.flashItem:setLocation(0, -518);
	self.flashItem:setScale(0.9, 0.9);
	-- self.flashItem:setCallBack(self, self.onClickShowBackPage);
	self.flashItem.openTime = 0.1;
	self.flashItem.rotateNum = 1;
	self.flashItem.canRotate = true;

	self.centerList = Lua_CenterList.new(self.content, 490, 270, Lua_AxisDefine.Horizontal);
	self.centerList:setCellList(Lua_CollectionBookCardDetailItem, 168, 248);
	self.centerList.type = 2;
	self.centerList:setTransformData(-30, 8, 0.72, 0.8);
	self.centerList:setShowCount(3);
	self.centerList:setLocation(0, -378);
	self.centerList:setCallBack(self, self.cutCallBack);
	UIUtils.setObjSiblingIndex(self.shareObj, self.centerList.siblingIndex);

	self.shareSp:addClickFuntion(self, self.onClickShowShareIcon); -- 分享显示icon
	self.worldIcon:addClickFuntion(self, self.onClickShareWorldIcon); -- 世界分享icon
	self.areaIcon:addClickFuntion(self, self.onClickShareAreaIcon); -- 频道分享icon
	self.showBtnSp:addClickFuntion(self, self.onClickShowBtnSp); -- 多功能icon
	self.lastIcon:addClickFuntion(self, self.onClickLastHeroIcon); -- 点击上一英雄
	self.nextIcon:addClickFuntion(self, self.onClickNextHeroIcon); -- 点击下一英雄
	self.classicCardSp:addClickFuntion(self, self.onClickClassicCardSp); -- 点击经典卡

	self:addLuaEvent("UPDATE_CBCARDDETAIL_REWARD", self, self.updateRewardState); -- 卡牌奖励更新
	self:addLuaEvent("UPDATE_CBCARDDETAIL_PUSHBOOK", self, self.updateBtnState); -- 卡牌放入卡册更新
	self:addLuaEvent("UPDATE_CBCARDDETAIL_ACTIVECARD", self, self.updateWindowInfo); -- 激活卡牌更新
end

function Lua_CollectionBookCardDetailWindow:showWin(param)
	self:superCall("showWin", param);

	self.cardId = param; 

	local cardId;
	local bClassicCard = DataCenter.collectionBookUtil:checkCardTypeById(self.cardId, Lua_CollectionBookUtil.CLASSIC_CARD);
	if bClassicCard then
		local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(self.cardId);
		cardId = DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(bagId, Lua_CollectionBookUtil.COMMON_CARD);
	else
		cardId = self.cardId;
	end
	self.curCommonCard = cardId;
	self:showCardList();
	self:updateWindowInfo(false);
end

--isActive,是否由于激活而进行更新
function Lua_CollectionBookCardDetailWindow:updateWindowInfo(isActive)
	if not DataCenter.collectionBookUtil:getSingleCardConfigById(self.cardId) then
		print("no card");
		return;
	end

	local flashId = DataCenter.collectionBookUtil:getCardConfigByCardIdAndType(self.cardId, Lua_CollectionBookUtil.FLASH_ID);
	if flashId == nil then
		return;
	end
	-- 閃卡
	local flashInfo = Lua_FlashCardVo.new(flashId);
	self:setFlashCardPos(flashInfo);
	self.flashItem:setData(flashInfo); 
	-- 解锁时间
	local cardData = DataCenter.collectionBookData:getCollectCardById(self.cardId);
	local unlockTimeStr = DataCenter.collectionBookData:getUnlockTimeStr(1, self.cardId, false);
	self.activeTimeTxt.text = unlockTimeStr;
	self.timeBg:setEnable(unlockTimeStr ~= nil);
	self.flashItem:setGray(unlockTimeStr == nil);
	-- 奖励
	self:updateRewardState();
	-- 特效
	self:updateCardEffect();
	-- 经典卡或典藏卡
	self:showClassicSp();
	-- 多功能按钮
	self:updateBtnState();
	-- 卡牌组
	self:updateShowCardId(isActive)
end

-- 奖励状态更新
function Lua_CollectionBookCardDetailWindow:updateRewardState()
	local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(self.cardId);
	local hasReward = DataCenter.collectionBookData:getCanReceiveByBagId(bagId);
	local bCommonCard = DataCenter.collectionBookUtil:checkCardTypeById(self.cardId, Lua_CollectionBookUtil.COMMON_CARD);
	self:showReward(hasReward and bCommonCard);
	self:showRewardRedDot(hasReward and bCommonCard);
end

function Lua_CollectionBookCardDetailWindow:showReward(bShow)
	if bShow then
		if self.rewardIcon == nil then
			self.rewardIcon = Lua_ItemIcon.new(self.content);
			self.rewardIcon:setClick(self, self.onClickReward);
			self.rewardIcon:setRectAnchor(1);
			self.rewardIcon:setLocation(235, -879, 0);
			self.rewardIcon:setScale(0.6, 0.6);

			local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(self.cardId);
			local reward = DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(bagId, Lua_CollectionBookUtil.CARDBAG_REWARD);
			if reward ~= nil and #reward > 0 then
				local tvo = Lua_ToolVo.createToolVo(reward[1][1], reward[1][2]);
				self.rewardIcon:setData(tvo);
			end
		end
		self.rewardIcon:setEnable(true);
	else
		if self.rewardIcon ~= nil then
			self.rewardIcon:setEnable(false);
		end
	end
end

function Lua_CollectionBookCardDetailWindow:showRewardRedDot(bShow)
	if bShow == true then
		if self.rewardRedPoint == nil then
			self.rewardRedPoint = Lua_RedPointIcon.new(self.content);
			self.rewardRedPoint:setRectAnchor(1);
			self.rewardRedPoint:setLocation(265, -849, 0);
			self.rewardRedPoint:createRedPointEff();
		end
		self.rewardRedPoint:updateRedPointShow(true);
	else
		if self.rewardRedPoint ~= nil then
			self.rewardRedPoint:updateRedPointShow(false);
		end
	end
end

function Lua_CollectionBookCardDetailWindow:setFlashCardPos(flashInfo)
	local itemPosY, timeTxtPosY, timeBgPosY = -518, -64, -64;
	local timeTxtPosX = 77;
	local timeBgWidget = 595;
	local bClassicCard = DataCenter.collectionBookUtil:checkCardTypeById(self.cardId, Lua_CollectionBookUtil.CLASSIC_CARD);
	if bClassicCard then
		local widget, height = flashInfo:getDistance();
		height = height ~= 0 and height / 2 or 0;
		itemPosY, timeTxtPosY, timeBgPosY = itemPosY - height, timeTxtPosY - height * 2, timeBgPosY - height * 2;
		timeTxtPosX = timeTxtPosX + widget / 2;
		timeBgWidget = timeBgWidget - widget;
	end

	self.flashItem:setLocation(0, itemPosY);
	self.timeBg:setLocation(-3, timeBgPosY);
	self.timeBg:SetDimensions(timeBgWidget, 41);
	self.activeTimeTxt:setLocation(timeTxtPosX, timeTxtPosY);
end

-- 特效
function Lua_CollectionBookCardDetailWindow:updateCardEffect()
	local isShowEffect = DataCenter.collectionBookUtil:checkShowEffectByCardId(self.cardId);
	self.flashItem:setBShowEffect(isShowEffect, true, "ui_scc_sk_0001", 0, 0, 1);
end

--分享
function Lua_CollectionBookCardDetailWindow:onClickShowShareIcon()
	local isShow = self.shareObj.activeSelf;
	self.shareObj:SetActive(not isShow);

	self.isOpenWorld = DataCenter.funcOpenData:isOpened(10228);
	self.worldIcon:setGray(not self.isOpenWorld);
	
	self.isOpenArea = DataCenter.funcOpenData:isOpened(10229);
	local isShow = DataCenter.roleData.league_id > 0 and self.isOpenArea;
	self.areaIcon:setGray(not isShow);
end

function Lua_CollectionBookCardDetailWindow:onClickShareWorldIcon()
	if not self.isOpenWorld then
		OperateAlert.showLangValue(410004);
	else
		self.shareObj:SetActive(false);
		local unlockTime = DataCenter.collectionBookData:getUnlockTimeStr(4, self.cardId, false);
		DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD, {cardId = self.cardId, active_time = unlockTime});
		Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_WORLD, "", false, false);
		OperateAlert.showLangValue(410071);
	end
end

function Lua_CollectionBookCardDetailWindow:onClickShareAreaIcon()
	if not self.isOpenArea then
		OperateAlert.showLangValue(410004);
	elseif DataCenter.roleData.league_id <= 0 then
		OperateAlert.showLangValue(410058);
	else
		self.shareObj:SetActive(false);
		local unlockTime = DataCenter.collectionBookData:getUnlockTimeStr(4, self.cardId, false);
		DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD, {cardId = self.cardId, active_time = unlockTime});
		Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_LEAGUE, "", false, false);
		OperateAlert.showLangValue(410071);
	end
end

-- 展示经典卡或典藏卡
function Lua_CollectionBookCardDetailWindow:showClassicSp()
	local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(self.cardId);
	local bShow = not (DataCenter.collectionBookUtil:checkBagTypeById(bagId, Lua_CollectionBookUtil.CREATE_CARD) or 
				  DataCenter.collectionBookUtil:checkBagTypeById(bagId, Lua_CollectionBookUtil.FRAME_CARD) );

	local bClassic = DataCenter.collectionBookUtil:checkCardTypeById(self.cardId, Lua_CollectionBookUtil.CLASSIC_CARD);
	if bShow and not bClassic then
		local classicCard = DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(bagId, Lua_CollectionBookUtil.CLASSIC_CARD);
		local bCompleted = DataCenter.collectionBookUtil:checkCompletedCard(classicCard);
		bShow = bCompleted == true;
	end

	if bShow then
		local spriteStr = bClassic and "xui_hb_button_13" or "xui_hb_button_12";
		self.classicCardSp:setAltas("collect_book_atlas", spriteStr);
		self.classicCardSp:setEnable(true);
		self.shareSp:setLocation(174.7, 52);
		self.shareBg:setScale(-1, -1, 1);
	else
		self.classicCardSp:setEnable(false);
		self.shareSp:setLocation(293, 52);
		self.shareBg:setScale(1, -1, 1);
	end

	self.lastIcon:setEnable(not bClassic);
	self.nextIcon:setEnable(not bClassic);

	local bActive = DataCenter.collectionBookData:getBActiveByCardId(self.cardId, Lua_CollectionBookUtil.UNLOCK_CARD, false);
	self.shareSp:setEnable(bActive);
end

-- 更新按钮的状态
function Lua_CollectionBookCardDetailWindow:updateBtnState()
	local bCompleted = DataCenter.collectionBookUtil:checkCompletedCard(self.cardId);
	if not bCompleted then
		print("this card is not complated ")
	end

	self:showBtnRedDot(false);
	local bClassicCard = DataCenter.collectionBookUtil:checkCardTypeById(self.cardId, Lua_CollectionBookUtil.CLASSIC_CARD);
	self.showBtnSp:setEnable(not bClassicCard);
	self.showBtnTxt:setEnable(not bClassicCard);
	if bClassicCard then
		return;
	end

	local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(self.cardId);
	local pushIdInBag = DataCenter.collectionBookData:bShowCardInBag(bagId, false);
	pushIdInBag = DataCenter.collectionBookData:getBActiveByCardId(pushIdInBag, Lua_CollectionBookUtil.UNLOCK_CARD, false) and pushIdInBag or nil;
	local bActive = DataCenter.collectionBookData:getBActiveByCardId(self.cardId, Lua_CollectionBookUtil.UNLOCK_CARD, false);

	if pushIdInBag == self.cardId then
		self.showBtnTxt:setLangValue(410036);--"展示中";
		self.btnActionIndex = 1;
	elseif bActive then
		self.showBtnTxt:setLangValue(410037);--"放入卡册";
		self.btnActionIndex = 2;
	else
		-- 【神兵卡-英雄系统收集】通过英雄系统收集
		local bCollectedFromHeroSystem = DataCenter.collectionBookUtil:checkCollectedFromHeroSystem(self.cardId);
		if bCollectedFromHeroSystem then
			self.showBtnTxt:setLangValue(410038);--"去获取";
			self.btnActionIndex = 3;
		end
		-- 【神兵卡-其他收集方式】	or 【英雄闪卡】
		local bOnlyCard = DataCenter.collectionBookUtil:checkCommonCardTypeById(self.cardId, Lua_CollectionBookUtil.ONLY_CARD);-- 仅有卡
		local bHeroCard = DataCenter.collectionBookUtil:checkCardTypeById(self.cardId, Lua_CollectionBookUtil.FLASH_CARD); -- 英雄闪卡
		if bOnlyCard or bHeroCard then
			local canActive = DataCenter.collectionBookUtil:canActiveByCardId(self.cardId);
			if canActive then
				self.showBtnTxt:setLangValue(410039);--"激活";
				self.btnActionIndex = 4;					
				self:showBtnRedDot(true);
			else
				self.showBtnTxt:setLangValue(410038);--"去获取";
				self.btnActionIndex = 5;
			end
		end
		--【皮肤闪卡】
		local bSkinCard = DataCenter.collectionBookUtil:checkCardTypeById(self.cardId, Lua_CollectionBookUtil.CLOTH_CARD); -- 皮肤闪卡
		if bSkinCard then
			self.showBtnTxt:setLangValue(410038);--"去获取";
			self.btnActionIndex = 6;
		end
	end
	self:showCardList();
end

function Lua_CollectionBookCardDetailWindow:onClickShowBtnSp()
	self:hideShareObj();-- 隐藏shareObj
	-- 展示中
	if self.btnActionIndex == 1 then 
		OperateAlert.showLangValue(410040);
	-- 放入卡册
	elseif self.btnActionIndex == 2 then 
		DataCenter.collectionBookData:updatePushIdInBag(self.cardId);
	-- 【神兵卡-英雄系统收集】：去获取 -->点击跳转英雄系统对应英雄图鉴页
	elseif self.btnActionIndex == 3 then 
		local collectionPath = DataCenter.collectionBookUtil:getCollectionHeroPathId();
		DataCenter.packUtil:openPathWindow(collectionPath, false);
	-- 【神兵卡-其他收集方式】 or 【英雄闪卡】:激活 -->服务端消息号激活
	elseif self.btnActionIndex == 4 then 
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sActiveCardInfo(self.cardId);
	-- 【神兵卡-其他收集方式】 or 【英雄闪卡】:去获取 -->点击弹出获取渠道tips
	elseif self.btnActionIndex == 5 then 
		local exchangeItems = DataCenter.collectionBookUtil:getCardConfigByCardIdAndType(self.cardId, Lua_CollectionBookUtil.CHANGE_ITEM);
		if exchangeItems ~= nil then
			local itemId = exchangeItems[1][1];
			DataCenter.packUtil:openPathWindow(itemId, false);
		else
			local flashCardCollectiPath = DataCenter.collectionBookUtil:getCollectionFlashPathId();
			DataCenter.packUtil:openPathWindow(flashCardCollectiPath, false);
		end
	-- 【皮肤闪卡】:去获取 -->点击跳转至英雄系统对应皮肤页面
	elseif self.btnActionIndex == 6 then 
		-- DataCenter.heroAtlasData:onOpenAtlasWindow(self.heroId,4, nil, nil);
		local collectionPath = DataCenter.collectionBookUtil:getCollectionSkinPathId();
		DataCenter.packUtil:openPathWindow(collectionPath, false);
	elseif self.btnActionIndex == 7 then
		OperateAlert.showLangValue(410033);
	end
end

-- 卡牌组
function Lua_CollectionBookCardDetailWindow:showCardList()
	local bClassicCard = DataCenter.collectionBookUtil:checkCardTypeById(self.cardId, Lua_CollectionBookUtil.CLASSIC_CARD);
	if bClassicCard then
		local bCompleteCard = DataCenter.collectionBookUtil:checkCompletedCard(self.cardId);
		if bCompleteCard then
			self:showClassicCard(true);
			self.centerList:setEnable(false);
		-- else
		end
	end
	
	if self.cardIdTab == nil or self.cardDir == nil then
		self.cardIdTab, self.cardDir = DataCenter.collectionBookData:getCardListByCardId(self.curCommonCard);
	end

	local index = self.cardDir[self.curCommonCard];
	self.centerList:setArrayData(self.cardIdTab);
	self.centerList:moveToIndex(index, true);
	self.curIndex = index;
end

function Lua_CollectionBookCardDetailWindow:updateShowCardId(isActive)
	local bClassicCard = DataCenter.collectionBookUtil:checkCardTypeById(self.cardId, Lua_CollectionBookUtil.CLASSIC_CARD);
	if bClassicCard then
		self.lastCardId = nil;
		self.nextCardId = nil;
	else
		local index = self.cardDir[self.cardId];
		index = index or 0;
		local lastIndex = index - 1;
		local nextIndex = index + 1;
		self.lastCardId = self.cardIdTab[lastIndex];
		self.nextCardId = self.cardIdTab[nextIndex];
		if isActive == nil then
			isActive = true;
		end
		if isActive then
			self.centerList:setArrayData(self.cardIdTab, false);
		end
	end
end

function Lua_CollectionBookCardDetailWindow:showBtnRedDot(bShow)
	if bShow == true then
		if self.btnRedPoint == nil then
			self.btnRedPoint = Lua_RedPointIcon.new(self.content);
			self.btnRedPoint:setRectAnchor(7);
			self.btnRedPoint:setLocation(94, 142, 0);
			self.btnRedPoint:createRedPointEff();
		end
		self.btnRedPoint:updateRedPointShow(true);
	else
		if self.btnRedPoint ~= nil then
			self.btnRedPoint:updateRedPointShow(false);
		end
	end
end

function Lua_CollectionBookCardDetailWindow:onShareBgClick()
end

function Lua_CollectionBookCardDetailWindow:hideShareObj()
	self.shareObj:SetActive(false);
end

function Lua_CollectionBookCardDetailWindow:onClickReward()
	self:hideShareObj();-- 隐藏shareObj
	local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(self.cardId);
	local hasReward = DataCenter.collectionBookData:getCanReceiveByBagId(bagId);
	if hasReward then
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sReceivedReward(bagId);
	else
		local reward = DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(bagId, Lua_CollectionBookUtil.CARDBAG_REWARD);
		if reward ~= nil and #reward > 0 then
			local tvo = Lua_ToolVo.createToolVo(reward[1][1], reward[1][2]); 
			DataCenter.packUtil:showItemInfo(tvo);
		end
	end
end

-- 点击上一英雄
function Lua_CollectionBookCardDetailWindow:onClickLastHeroIcon()
	self:hideShareObj();-- 隐藏shareObj
	if self.lastCardId == nil then
		OperateAlert.showLangValue(410041);
	else
		self.centerList:moveToIndex(self.curIndex - 1);
	end
end

-- 点击下一英雄
function Lua_CollectionBookCardDetailWindow:onClickNextHeroIcon()
	self:hideShareObj();-- 隐藏shareObj
	-- 更改self.ordinaryCardId
	if self.nextCardId == nil then
		OperateAlert.showLangValue(410042);
	else
		self.centerList:moveToIndex(self.curIndex + 1);
	end
end

--滑动切换回调，val：true上一个，false下一个
function Lua_CollectionBookCardDetailWindow:cutCallBack()
	self:hideShareObj();-- 隐藏shareObj
	local index = self.centerList.curIndex;
	if index == self.curIndex then
		return;
	end
	if index < self.curIndex then
		if self.lastCardId == nil then
			return;
		end
		self.cardId = self.lastCardId;
		self.curCommonCard = self.cardId;
	elseif index > self.curIndex then
		if self.nextCardId == nil then
			return;
		end
		self.cardId = self.nextCardId;
		self.curCommonCard = self.cardId;	
	end
	self.curIndex = index;
	self:updateWindowInfo(false);
end

-- 经典卡/神兵卡互换
function Lua_CollectionBookCardDetailWindow:onClickClassicCardSp()
	if self.centerList.isMoveing == true then
		return;
	end

	self:hideShareObj();-- 隐藏shareObj

	local bClassicCard = DataCenter.collectionBookUtil:checkCardTypeById(self.cardId, Lua_CollectionBookUtil.CLASSIC_CARD);
	local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(self.cardId);
	local cardId = bClassicCard and self.curCommonCard or DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(bagId, Lua_CollectionBookUtil.CLASSIC_CARD);
	self.cardId = cardId;
	self:updateWindowInfo(false);

    if bClassicCard then
    	-- self.classicItem:setEnable(false);
    	self:showClassicCard(false);
		self.centerList:setEnable(true);
	else
		self:showClassicCard(true);
		self.centerList:setEnable(false);
	end
end

function Lua_CollectionBookCardDetailWindow:showClassicCard(bShow)
	if bShow then
		if self.classicItem == nil then
			local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(self.cardId);
			local classicCardId = DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(bagId, Lua_CollectionBookUtil.CLASSIC_CARD);
			self.classicItem = Lua_CollectionBookCardDetailItem.new(self.content);
			self.classicItem:setLocation(0, -378);
			self.classicItem:setScale(0.8, 0.8, 1);
			UIUtils.setObjSiblingIndex(self.shareObj, self.classicItem.siblingIndex);
			self.classicItem:setData(classicCardId, true);
		end
		self.classicItem:setEnable(true);
	else
		if self.classicItem ~= nil then
			self.classicItem:setEnable(false);
		end
	end
end

function Lua_CollectionBookCardDetailWindow:dispose()
	if self.cardItems ~= nil then
		for k, v in pairs(self.cardItems) do
			v:dispose();
			v = nil;
		end
	end
	if self.rewardRedPoint ~= nil then
		self.rewardRedPoint:dispose();
		self.rewardRedPoint = nil;
	end
	if self.btnRedPoint ~= nil then
		self.btnRedPoint:dispose();
		self.btnRedPoint = nil;
	end
	if self.rewardIcon ~= nil then
		self.rewardIcon:dispose();
		self.rewardIcon = nil;
	end
	if self.flashItem ~= nil then
		self.flashItem:dispose();
		self.flashItem = nil;
	end
	if self.centerList ~= nil then
		self.centerList:dispose();
		self.centerList = nil;
	end
	if self.classicItem ~= nil then
		self.classicItem:dispose();
		self.classicItem = nil;
	end
	self.cardId = nil;
	self.curCommonCard = nil;
	self.cardIdTab = nil;
	self.cardIdTab = nil;
	self:superCall("dispose");
end























Lua_CollectionBookCardDetailItem = class("Lua_CollectionBookCardDetailItem", Lua_CenterCell);
function Lua_CollectionBookCardDetailItem:ctor(p, index)
	self:superCall("ctor", p, "CollectionBookCardDetailItem_skin");
end

function Lua_CollectionBookCardDetailItem:buildShowItem()
	self:superCall("buildShowItem");

	self.showSp:setEnable(false);
	self.blackMask = UICreate.createUIAtlasImage(self.content, "common_altas_1", "black_mask", 0, 0, 188, 245);
	self.blackMask.alpha = 0.7;
end

function Lua_CollectionBookCardDetailItem:setData(data, isClassic)
	if data == nil then
		return;
	end

	if isClassic then
		self.blackMask:setEnable(false);
		self.cardNameTxt:setLocation(3, -103);
	else
		local val = self:checkInBound(0, 0);
		self.blackMask:setEnable(not val);
		self.cardNameTxt:setLocation(3, -226);
	end

	self.data = data;
	local cardId = data;
	local bCompleteCard = DataCenter.collectionBookUtil:checkCompletedCard(cardId);
	if bCompleteCard then
		local bActive = DataCenter.collectionBookData:getBActiveByCardId(cardId, Lua_CollectionBookUtil.UNLOCK_CARD, false);
		local flashId = DataCenter.collectionBookUtil:getCardConfigByCardIdAndType(cardId, Lua_CollectionBookUtil.FLASH_ID);
		local flashInfo = Lua_FlashCardVo.new(flashId); 
		self.cardIcon:setUrl(flashInfo.flash_path_2);
		self.cardIcon:setGray(not bActive);
		self.cardNameTxt.text = flashInfo.flash_card_name;

		local str;
		local exchangeItem = DataCenter.collectionBookUtil:getCardConfigByCardIdAndType(cardId, Lua_CollectionBookUtil.CHANGE_ITEM);
		if exchangeItem and not bActive then
			local curCount = DataCenter.packData:getItemCountById(exchangeItem[1][1]);
			local item = Lua_ToolVo.createToolVo(exchangeItem[1][1]);
			str = LanUtil.formateStr(410051, curCount, exchangeItem[1][2]);
			self.costSp:setAltas(item.atlas, item.sprite);
			self.costSp:setEnable(true);
			self.costBg:setEnable(true);
		else
			self.costSp:setEnable(false);
			self.costBg:setEnable(false);
		end
		self.costTxt.text = str;

		local canActive = DataCenter.collectionBookUtil:canActiveByCardId(cardId);
		self:showRedDot(canActive);

		local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(cardId);
		local bShow = DataCenter.collectionBookData:bShowCardInBag(bagId, false) == self.data;
		self.showSp:setEnable(bShow);

		bShow = DataCenter.collectionBookUtil:checkShowEffectByCardId(self.data);
		local spriteStr = bShow and "xui_scc_widget_31" or "xui_hb_widget_15";
		self.nameBg:setAltas("collect_book_atlas_2", spriteStr);

		bShow =	DataCenter.collectionBookUtil:checkCardTypeById(cardId, Lua_CollectionBookUtil.FLASH_CARD) or 
						 DataCenter.collectionBookUtil:checkCardTypeById(cardId, Lua_CollectionBookUtil.CLOTH_CARD);
		local spriteStr = bShow and "xui_scc_widget_31" or "xui_hb_widget_15";
		self.nameBg:setAltas("collect_book_atlas_2", spriteStr);
	else
		print(data.."未制作完成");
	end
end

function Lua_CollectionBookCardDetailItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(81, 117, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_CollectionBookCardDetailItem:dispose()	
	if self.blackMask ~= nil then
		self.blackMask:dispose();
		self.blackMask = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self:superCall("dispose");
end