checkRequire("Lua_CollectionBookMainPanel");
checkRequire("Lua_CollectionBookRankPanel");
checkRequire("Lua_CollectionBookFlashPanel");
Lua_CollectionBookDetailWindow = class("Lua_CollectionBookDetailWindow", Lua_Window);
function Lua_CollectionBookDetailWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_CollectionBookDetailWindow";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;
	self.showWinBg = true;
	self.winBgPath = "/images/collect_book/xui_scc_bg_1.jpg";

	self.isShareWindow = false;
	-- self:initPreRawImgPath();
end

function Lua_CollectionBookDetailWindow:initPreRawImgPath()
	local rawImgPaths = {
		"/images/infinity_hall/ui_wqzd_bj_002.png",
		"/images/common/ui_common_window_016.png",
		"/images/infinity_hall/ui_wqzd_bj_002.jpg"
	};
	for i = 1, #rawImgPaths do
		self:addPreLoadRes(rawImgPaths[i], Lua_LoadFileType.IMG);
	end
end

function Lua_CollectionBookDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:createBottomTabList();
end

function Lua_CollectionBookDetailWindow:createBottomTabList()
	self.showBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_widget_002", 0, 60, 720, 121);
    self.showBg.anchor = Lua_WindowUtil.getAnchor(7);
    self.showBg.siblingIndex = 1;

    self.panelObj = {};
	self.tabInfo = Array();
    self.tabInfo:add({ panel = Lua_CollectionBookMainPanel,  textAtlas = "collect_book_atlas_2", textNormalSprite = "xui_scc_zgnbutton_4_n", textSelectedSprite = "xui_scc_zgnbutton_4_p", textUnOpenSprite = "xui_scc_zgnbutton_4_d"});
    if not self.isShareWindow then
	    self.tabInfo:add({ panel = Lua_CollectionBookRankPanel,  textAtlas = "collect_book_atlas_2", textNormalSprite = "xui_scc_zgnbutton_1_n", textSelectedSprite = "xui_scc_zgnbutton_1_p", textUnOpenSprite = "xui_scc_zgnbutton_1_d", redPointId = Lua_RedPointList.CollectionBook_Rank});
	    self.tabInfo:add({ panel = Lua_CollectionBookFlashPanel, textAtlas = "collect_book_atlas_2", textNormalSprite = "xui_scc_zgnbutton_2_n", textSelectedSprite = "xui_scc_zgnbutton_2_p", textUnOpenSprite = "xui_scc_zgnbutton_2_d"});
	end

    self.tabBtnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.tabBtnList:setRectAnchor(7);
    self.tabBtnList:setLocation(182, 54, 0);
    self.tabBtnList.pivot = -1;
    self.tabBtnList:setButtonStyle("common_altas_1", "ui_common_button_001_b", "ui_common_button_001_b", 118, 108, 0.01, 1);
    self.tabBtnList:setButtonLine("common_altas_1", "ui_common_line_011", 2, 108, 0, 0, 1);
    self.tabBtnList:setButtonItem(120, 108);
    self.tabBtnList:setRedPoint(42, 41);
    self.tabBtnList:setClickCallBack(self, self.onTabBtnClick);
    self.tabBtnList:setData(self.tabInfo);
    self.tabBtnList:setEnable(not self.isShareWindow);
end

function Lua_CollectionBookDetailWindow:showWin(param)
	self:superCall("showWin", param);

	local toIndex;
	if param ~= nil then
		if type(param) == "table" and param.openIdx ~= nil then
			toIndex = param.openIdx;
		elseif type(param) == "string" or type(param) == "number" then
			toIndex = tonumber(param);
		end
	end

	if toIndex ~= nil then
		self.tabBtnList:setSelected(toIndex);
	end
end

function Lua_CollectionBookDetailWindow:onTabBtnClick(index)
	if self.selectedIndex == index then
		return;
	end

	self.panel = self.panelObj[self.selectedIndex];
	if self.panel ~= nil then
		self.panel:setEnable(false);
	end
	
	self.selectedIndex = index;
	self.panel = self.panelObj[index];
	if self.panel == nil then
		local paneName = self.tabInfo[index] ~= nil and self.tabInfo[index].panel ~= nil and self.tabInfo[index].panel or nil;
		if paneName ~= nil then
			self.panel = paneName.new(self.content);
			self.panel:setSiblingIndex(1);
			self.panel:setRectAnchor(9);
			self.panelObj[index] = self.panel;
		else
			return;
		end
	else
		self.panel:setEnable(true);
		self.panel:onScreenResize(self.adaptHeight);
	end

	if self.panel.setSharePanel ~= nil then
		self.panel:setSharePanel(self.isShareWindow);
	end

	if self.panel.playTween ~= nil then
		self.panel:playTween();
	end
end

function Lua_CollectionBookDetailWindow:dispose()
	if self.tabInfo ~= nil then
		self.tabInfo:dispose();
		self.tabInfo:clear();
		self.tabInfo = nil;
	end
	if self.tabBtnList ~= nil then
		self.tabBtnList:dispose();
		self.tabBtnList = nil;
	end
	if self.panelObj ~= nil then
		for k, v in pairs(self.panelObj) do
			v:dispose();
			v = nil;
		end
		self.panelObj = nil;
	end

	self:superCall("dispose");
end