Lua_CollectionBookEntranceWindow = class("Lua_CollectionBookEntranceWindow", Lua_Window);
function Lua_CollectionBookEntranceWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_CollectionBookEntranceWindow";
	self.skinName = "CollectionBookEntranceWindow_skin";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;

	self.showWinBg = true;
	self.winBgPath = "/images/collect_book/xui_scc_bg_1.jpg";

	-- self.setImgPath = "/images/common/ui_common_window_016.png";
    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
    self:addPreLoadRes("/images/collect_book/xui_scc_widget_2.png", Lua_LoadFileType.IMG);
    self:addPreLoadRes("/images/collect_book/xui_scc_widget_1.png", Lua_LoadFileType.IMG);
end

function Lua_CollectionBookEntranceWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:initWindowItem();
end

function Lua_CollectionBookEntranceWindow:initWindowItem()
	self.redPointPosList = {
		{posX = 130, posY =  254, rotZ =  3, redPointId = Lua_RedPointList.CollectionBook_Fetter,   parentName = "fetterSpObj" },
		{posX = 141, posY =  -24, rotZ =  3, redPointId = Lua_RedPointList.CollectionBook_Entrance, parentName = "weaponsSpObj" }
	};

	self.showBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_widget_002", 0, 60, 720, 121);
    self.showBg.anchor = Lua_WindowUtil.getAnchor(7);
    self.showBg.siblingIndex = 1;

    self:showWeaponRedPoint();
	self.weaponsSp.clickScale = false;
    self.weaponsSp:addMousDownFuntion(self, self.onMouseDownWeaponsSp);
	self.weaponsSp:addMouseUpFuntion(self, self.onMouseUpWeaponsSp);

	self.fetterSp.clickScale = false;
    self.fetterSp:addMousDownFuntion(self, self.onMouseDownFetterSp);
	self.fetterSp:addMouseUpFuntion(self, self.onMouseUpFetterSp);
end

function Lua_CollectionBookEntranceWindow:onMouseDownWeaponsSp()
	LuaUtil.setObjScale(self.weaponsSpObj, 1.1, 1.1, 1.1);
end

function Lua_CollectionBookEntranceWindow:onMouseUpWeaponsSp()
	Lua_WindowUtil.openWin("Lua_CollectionWeaponWindow", Lua_WinParam.ACTION_OPEN);
	LuaUtil.setObjScale(self.weaponsSpObj, 1, 1, 1);
end

function Lua_CollectionBookEntranceWindow:onMouseDownFetterSp()
	LuaUtil.setObjScale(self.fetterSpObj, 1.1, 1.1, 1.1);
end

function Lua_CollectionBookEntranceWindow:onMouseUpFetterSp()
	Lua_WindowUtil.openWin("Lua_CollectionBookHeroFetterWindow", Lua_WinParam.ACTION_OPEN);
	LuaUtil.setObjScale(self.fetterSpObj, 1, 1, 1);
end

function Lua_CollectionBookEntranceWindow:showWeaponRedPoint()
	if self.redPointList == nil then
		self.redPointList = {};
	end

	local obj;
	for i = 1, #self.redPointPosList do
		obj = self.redPointPosList[i];
		self.redPointList[i] = Lua_RedPointIcon.new(self[obj.parentName], obj.redPointId);
		self.redPointList[i]:setLocation(obj.posX, obj.posY);
		self.redPointList[i]:setRot(0, 0, obj.rotZ);
	end
end


function Lua_CollectionBookEntranceWindow:dispose()
	if self.redPointPosList ~= nil then
		self.redPointPosList = nil;
	end
	if self.redPointList ~= nil then
		for k, v in pairs(self.redPointList) do 
			v:dispose();
			v = nil;
		end
		self.redPointList = nil;
	end
	self:superCall("dispose");
end