-- 后期删除Lua_HeroFetterPanel
Lua_CollectionBookHeroFetterWindow = class("Lua_CollectionBookHeroFetterWindow", Lua_Window);
function Lua_CollectionBookHeroFetterWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_CollectionBookHeroFetterWindow";
	self.skinName = "CollectionBookHeroFetterWindow_skin";
	self.winBgPath = "/images/common/xui_common_bg_001.jpg";
	self.showWinBg = true;
	self.isFullSizeWin = true;
	self.showBackBtn = true;
	self.showBlackMask = true;
end

function Lua_CollectionBookHeroFetterWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content);
	self.roleInfoPanel:setRectAnchor(1);

	self.bottomSp.siblingIndex = 1;
 	self.dragContainer = Lua_DragContainer.new(self.content, 690, 1164 + self.adaptHeight, Lua_AxisDefine.Vertical);
    self.dragContainer:setLocation(2, -9);

    self.tipsIcon:addClickFuntion(self, self.onTipClick);
    self.totalAttribSp:addClickFuntion(self, self.onClickTotalAttribSp);
	self:addLuaEvent("UPDATE_COLLECTBOOK_HEROFETTER_INFO", self, self.updateFetterInfo);
	if DataCenter.collectionBookData.bUpdateDataFromServer ~= true then
        Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sHeroFetter(); 
	else
   		self:updateFetterInfo();
   	end
end

function Lua_CollectionBookHeroFetterWindow:showWin(param)
	self:superCall("showWin", param);
end

function Lua_CollectionBookHeroFetterWindow:onScreenResize()
	self:superCall("onScreenResize");

	self.dragContainer:setContentRect(690, 1164 + self.adaptHeight);
end

function Lua_CollectionBookHeroFetterWindow:updateFetterInfo(bNotUpdate)
 	local list = DataCenter.collectionBookData:getFetterIdList();
	self.dragContainer:clearList();
	if list == nil then
		return;
	end
	for i = 1, #list do
		self.dragContainer:addSubContainer(Lua_CollectionBookHeroFetterCell, list[i], false, 0);
	end
	self.dragContainer:updateChildPos();

	if not bNotUpdate then
		local index = DataCenter.collectionBookData:getHasFetterRewardIndex();
		if index ~= nil then 
			self.dragContainer:moveToIndex(index, true);
		else
			if self.firstEnter == nil then
				self.dragContainer:moveToIndex(1, true);
			end
		end
	end

	self.firstEnter = true;
end

function Lua_CollectionBookHeroFetterWindow:onTipClick()
	local param = { des = LanUtil.getValue(410053), posX = 164, posY = -236 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, param);
end

function Lua_CollectionBookHeroFetterWindow:onClickTotalAttribSp()
	Lua_WindowUtil.openWin("Lua_CollectionBookFetterTotalAttribWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_CollectionBookHeroFetterWindow:dispose()
	if self.roleInfoPanel ~= nil then
		self.roleInfoPanel:dispose();
		self.roleInfoPanel = nil;
	end
	if self.dragContainer ~= nil then 
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	self:superCall("dispose");
end































Lua_CollectionBookHeroFetterCell = class("Lua_CollectionBookHeroFetterCell", Lua_ListCell);
function Lua_CollectionBookHeroFetterCell:ctor(p)
    self:superCall("ctor", p,"CollectionBookHeroFetterCell_skin");
end

function Lua_CollectionBookHeroFetterCell:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardObj:SetActive(false);
end

function Lua_CollectionBookHeroFetterCell:setData(data)
    if data == nil then
		return;
	end

	self.data = data;
	local config = DataCenter.collectionBookUtil:getFetterConfigById(self.data);
	if config ~= nil then
		local serverData = DataCenter.collectionBookData:getHeroFetterVoById(self.data);
		local heroDic = serverData.heroDir;
		local curValue, totalValue = serverData.activeNum, #config.hero_list;
		local str = curValue < totalValue and LanUtil.getValue(410063) or LanUtil.getValue(410064);
		self.activeProcessTxt.text = LanUtil.formateStr(str, curValue, totalValue);
		self.fetterNameTxt.text = config.name;

		local isActive = serverData.rewardState ~= 0;
		local descStr  = config.health or 0;
		self.healthTxt.text = isActive and LanUtil.formateStr(410065, descStr) or LanUtil.formateStr(410066, descStr);
		descStr = config.attack or 0;
		self.attackTxt.text = isActive and LanUtil.formateStr(410067, descStr) or LanUtil.formateStr(410068, descStr);
		descStr = config.defence or 0;
		self.defenceTxt.text = isActive and LanUtil.formateStr(410069, descStr) or LanUtil.formateStr(410070, descStr);
		self.heroCount = #config.hero_list;
		self:updateDisplay();
		self:showRewardIcon(serverData.rewardState == 1);
		self:showRewardRedDot(serverData.rewardState == 1);
		self:showHeroList(config.hero_list);
	end
end

function Lua_CollectionBookHeroFetterCell:updateDisplay()
	if self.heroCount > 3 then
		self.bg_1:SetDimensions(696, 745);
		self.bg_2:SetDimensions(665, 615);
	else
		self.bg_1:SetDimensions(696, 431);
		self.bg_2:SetDimensions(665, 305);
	end
end

function Lua_CollectionBookHeroFetterCell:getWidth()
	return 696;
end

function Lua_CollectionBookHeroFetterCell:getHeight()
	-- return 320 + self.count * 40;
	return self.heroCount > 3 and 765 or 451;
end


function Lua_CollectionBookHeroFetterCell:showHeroList(heroList)
	if heroList == nil then
		return;
	end
	if self.heroList == nil then
		self.heroList = {};
	end

	local item;
	local index;
	local count = #heroList;
	for i = 1, count do
		item = self.heroList[i];
		if item == nil then
			item = Lua_CollectionBookHeroFetterHeroItem.new(self.content);
			item:setRectAnchor(1);
			self.heroList[i] = item;
		end
		item:setEnable(true);
		item:setData(heroList[i], self.data);
		index = i - 1;
		item:setLocation(-235 + index % 3 * 225, -288 - Mathf.Floor(index / 3) * 315);
	end

	for i = count + 1, #self.heroList do
		self.heroList[i]:setEnable(false);
	end
end

function Lua_CollectionBookHeroFetterCell:showRewardIcon(bShow)
	if bShow then
		if self.rewardIcon == nil then
			self.rewardIcon = Lua_ItemIcon.new(self.content);
			self.rewardIcon:setScale(0.7, 0.7, 0.7);
			self.rewardIcon:setRectAnchor(1);
			self.rewardIcon:setClick(self, self.onReceivedClick);
			self.rewardIcon:setLocation(284, -41);
		end

		self.rewardIcon:setEnable(true);
		self.rewardObj:SetActive(true);
		local config = DataCenter.collectionBookUtil:getFetterConfigById(self.data);
		if config ~= nil and config.reward ~= nil then
			local reward = config.reward[1];
			local tvo = Lua_ToolVo.createToolVo(reward[1], reward[2]);
			self.rewardIcon:setData(tvo);
		end
	else
		if self.rewardIcon ~= nil then
			self.rewardIcon:setEnable(false);
		end
		self.rewardObj:SetActive(false);
	end
end

function Lua_CollectionBookHeroFetterCell:showRewardRedDot(bShow)
	if bShow == true then
		if self.rewardRedPoint == nil then
			self.rewardRedPoint = Lua_RedPointIcon.new(self.content);
			self.rewardRedPoint:setRectAnchor(1);
			self.rewardRedPoint:setLocation(320, 0, 0);
			self.rewardRedPoint:createRedPointEff();
		end
		self.rewardRedPoint:updateRedPointShow(true);
	else
		if self.rewardRedPoint ~= nil then
			self.rewardRedPoint:updateRedPointShow(false);
		end
	end
end

function Lua_CollectionBookHeroFetterCell:onReceivedClick()
	if self.data ~= nil then
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sReceiveFetterReward(self.data);
	end
end

function Lua_CollectionBookHeroFetterCell:dispose()
	if self.rewardIcon ~= nil then
		self.rewardIcon:dispose();
		self.rewardIcon = nil;
	end
	if self.heroList ~= nil then
		for i = 1, #self.heroList do
			self.heroList[i]:dispose();
			self.heroList[i] = nil;
		end
		self.heroList = nil;
	end
	self:superCall("dispose");
end









Lua_CollectionBookHeroFetterHeroItem = class("Lua_CollectionBookHeroFetterHeroItem", Lua_DisplayObject);
function Lua_CollectionBookHeroFetterHeroItem:ctor(p)
	self:superCall("ctor", p, "CollectionBookHeroFetterHeroItem_skin");
end

function Lua_CollectionBookHeroFetterHeroItem:buildShowItem()
	self:superCall("buildShowItem");

end

function Lua_CollectionBookHeroFetterHeroItem:setData(data, fetterId)
    if data == nil then
		return;
	end

	self.data = data[1];
	local heroVo = Lua_HeroVo.new(self.data);
	local flashCardId = heroVo.cardList and heroVo.cardList[1] or nil;
	if flashCardId ~= nil then
		local flashCardInfo = Lua_FlashCardVo.new(flashCardId);
		if flashCardInfo ~= nil then
			self.heroImg:setUrl(flashCardInfo.showFrontPagePath);
		end
	end
	self.heroAttriSp:setAltas("common_altas_3", heroVo.campSprite);
	self.heroNameTxt.text = heroVo.name;

	local vo = DataCenter.collectionBookData:getHeroFetterVoById(fetterId);
	local isGray = not vo.heroDir[self.data];
	self:showGray(isGray);
end

function Lua_CollectionBookHeroFetterHeroItem:showGray(bShow)
	self.heroImg:setGray(bShow);
	self.heroAttriSp:setGray(bShow);
end

function Lua_CollectionBookHeroFetterHeroItem:dispose()
	self:superCall("dispose");
end