checkRequire("Lua_CollectionBookPageCardItem");
Lua_CollectionBookMainPanel = class("Lua_CollectionBookMainPanel", Lua_DisplayObject);
function Lua_CollectionBookMainPanel:ctor(p)
	self:superCall("ctor", p, "CollectionBookMainPanel_skin");
end

function Lua_CollectionBookMainPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.showPageCardCount = 4; -- 页面展示卡牌数量

	--勾选框
	self.selectedBox:setDir(0);
	self.selectedBox:addBoxChange(self, self.onSelectedBoxChange);

	self.tipsIcon:addClickFuntion(self, self.onClickTipsIcon); -- 提示Icon
	self.lastPageSp:addClickFuntion(self, self.onClickLastPageBtn); -- 上一页
	self.nextPageSp:addClickFuntion(self, self.onClickNextPageBtn); -- 下一页
end

function Lua_CollectionBookMainPanel:createTabBtnList()
	if self.btnList == nil then
		local font_size = 34;
		local hasLianDongCard = DataCenter.collectionBookUtil.hasLianDongCard;
		self.tabBtnInfo = Array();
		self.tabBtnInfo:add({ textStr = LanUtil.getValue(410013) });
		self.tabBtnInfo:add({ textStr = LanUtil.getValue(410014) });
		self.tabBtnInfo:add({ textStr = LanUtil.getValue(410015) });
		if hasLianDongCard then
			self.tabBtnInfo:add({ textStr = LanUtil.getValue(410016) });
			font_size = 28;
		end

		local widget = Mathf.Floor(680 / self.tabBtnInfo:getSize());
		local height = 62;
		self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
		self.btnList:setLocation(3, 154, 0);
		self.btnList:setButtonStyle("common_altas_1", "xui_common_button_005_n", "xui_common_button_004_n", widget, height);
		self.btnList:setButtonText(0, 0, "756150", "8f5123", font_size, font_size, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
		self.btnList:setButtonItem(widget, height);
		self.btnList:setClickCallBack(self, self.onBtnClick);
		self.btnList:setData(self.tabBtnInfo);
		self.btnList:setRectAnchor(7);
	end
end

function Lua_CollectionBookMainPanel:showNoneCard(bool)
	self.noneCardSp:setEnable(bool);
	self.noneCardTxt:setEnable(bool);
end

function Lua_CollectionBookMainPanel:setSharePanel(isSharePanel)
	self.isSharePanel = isSharePanel;

	local otherPlayerInfo = DataCenter.collectionBookData:getOtherPlayerInfo();
	if self.isSharePanel then
		self.tipsIcon:setEnable(false);
		self.activityNameSp:setEnable(false);
		self.playerNameBg:setEnable(true);
		self.activityNameTxt.text = nil;
		self.playerNameTxt.text = otherPlayerInfo.name;
	else
		self.tipsIcon:setEnable(true);
		self.activityNameSp:setEnable(true);
		self.playerNameBg:setEnable(false);
		self.activityNameTxt:setLangValue(410013);
		self.playerNameTxt.text = nil;
	end

	self:createTabBtnList();
	local selectedIndex, selectedTab = self:showHasRedPointCard();
	self.firstCardListIndex = selectedIndex; 
	self.btnList:setSelected(selectedTab);

	if not self.isSharePanel then
		self:addLuaEvent("UPDATE_CBCARDDETAIL_PUSHBOOK", self, self.updateCardList); -- 卡牌放入卡册更新
		self:addLuaEvent("UPDATE_CBCARDDETAIL_ACTIVECARD", self, self.updateCardList); -- 卡牌激活更新
		self:addLuaEvent("UPDATE_CBCARDDETAIL_UPDATECARD_REDPOINT", self, self.updateCardList); -- 卡牌红点数据更新
	end
end

function Lua_CollectionBookMainPanel:onBtnClick(index)
	if self.selectedIndex == index then
		return;
	end

	self.selectedIndex = index;
	if self.cardListIndex == nil then
		self.cardListIndex = self.firstCardListIndex;
	else
		self.cardListIndex = 1;
	end 
	self:updateCardList();
	self:controlTimer();
end

function Lua_CollectionBookMainPanel:showHasRedPointCard()
	if self.isSharePanel then
		return 1, 1;
	end
	local type = 1;
	local selectedIndex = self:showHasRedPointCardByType(type);
	if selectedIndex ~= nil then
		return selectedIndex, type;
	end

	type = 3;
	selectedIndex = self:showHasRedPointCardByType(type);
	if selectedIndex ~= nil then
		return selectedIndex, type;
	end

	local hasLianDongCard = DataCenter.collectionBookUtil.hasLianDongCard;
	if hasLianDongCard then
		type = 4;
		selectedIndex = self:showHasRedPointCardByType(type);
		if selectedIndex ~= nil then
			return selectedIndex, type;
		end
	end

	return 1, 1;
end

function Lua_CollectionBookMainPanel:showHasRedPointCardByType(type)
	local cardId;
	local bCompleted;
	local cardDataList = DataCenter.collectionBookData:getCardListByType(type, self.isSelected, false);
	local cardListCount = #cardDataList;
	for i = 1, cardListCount do
		cardId = cardDataList[i];
		bCompleted = DataCenter.collectionBookUtil:checkCompletedCard(cardId);
		if bCompleted and DataCenter.collectionBookData:bShowRedPointByCardId(cardId) then
			local num = Mathf.Floor(i / self.showPageCardCount);
			local residueNum = i % self.showPageCardCount;
			if residueNum == 0 then
				num = num - 1;
			end
			local selectedIndex = num * self.showPageCardCount + 1;
			return selectedIndex;
		end
	end
end

function Lua_CollectionBookMainPanel:updateCardList()
	self.isClassicCard = self.selectedIndex == 2;
	self.cardDataList = DataCenter.collectionBookData:getCardListByType(self.selectedIndex, self.isSelected, self.isSharePanel);
	if not self.isClassicCard then
		self.ordinaryCardCount, self.totalOrdinaryCardCount, self.flashCardCount, self.totalFlashCardCount =
			DataCenter.collectionBookData:getCardCountRadio(self.cardDataList, self.isSharePanel);
	else
		self.classicCount, self.totalClassicCount = DataCenter.collectionBookData:getClassicCardCountRadio(self.cardDataList, self.isSharePanel);
	end
	self.cardListCount = #self.cardDataList;
	self:showNoneCard(self.cardListCount == 0);
	self:updateCardItemList();
	self:updatePageNumTxt();
end

function Lua_CollectionBookMainPanel:getCardItem(index)
	if self.cardItemList == nil then
		self.cardItemList = {};
	end

	local item = self.cardItemList[index];
	if item == nil then
		item = Lua_CollectionBookPageCardItem.new(self.content);
		self.cardItemList[index] = item;
	end

	return item;
end

function Lua_CollectionBookMainPanel:updateCardItemList()
	local index;
	local cardId;
	local cardItem;
	for i = 1, self.showPageCardCount do
		index = self.cardListIndex + (i - 1);
		cardId = self.cardDataList[index];
		cardItem = self:getCardItem(i);
		if cardId ~= nil then
			cardItem:setData(cardId, i, self.isSharePanel);
			cardItem:setEnable(true);
		else
			cardItem:setEnable(false);
		end
	end
end

function Lua_CollectionBookMainPanel:updatePageNumTxt()
	local num = Mathf.Ceil(self.cardListIndex / self.showPageCardCount);
	local curPageNum = num == 0 and 1 or num;

	num = Mathf.Ceil(self.cardListCount / self.showPageCardCount);
	local totalPageNum = num == 0 and 1 or num;
	self.pageNumTxt.text = LanUtil.formateStr(410024, curPageNum, totalPageNum);
end

function Lua_CollectionBookMainPanel:controlTimer()
	-- self.switchIndex = nil; --收集卡牌数量切换index
	if self.selectedIndex == 2 then -- 页签index
		self:endTimer();
		self:showCollectCountTxt();
	else	
		self:endTimer();
		self:startTimer();
		self:showCollectCountTxt(true);
	end
end

function Lua_CollectionBookMainPanel:updatePanelInfo()
end

function Lua_CollectionBookMainPanel:showWin(param)
	self:superCall("showWin", param);

end

function Lua_CollectionBookMainPanel:onSelectedBoxChange(val)
	self.isSelected = self.isSelected == nil and true or not self.isSelected;
	self.cardListIndex = 1; 
	self:updateCardList();
	self:endTimer();
	self:startTimer();
	self:showCollectCountTxt();
end

function Lua_CollectionBookMainPanel:onClickLastPageBtn()
	local index = self.cardListIndex - self.showPageCardCount;
	if index < 1 then
		OperateAlert.showLangValue(410025);
		return;
	end
	self.cardListIndex = index;
	self:updateCardItemList();
	self:updatePageNumTxt();
end

function Lua_CollectionBookMainPanel:onClickNextPageBtn()
	local index = self.cardListIndex + self.showPageCardCount;
	if index > self.cardListCount then
		OperateAlert.showLangValue(410026);
		return;
	end

	self.cardListIndex = index;
	self:updateCardItemList();
	self:updatePageNumTxt();
end

function Lua_CollectionBookMainPanel:onClickTipsIcon()
	local tipsData = { des = LanUtil.getValue(410027), posX = 174, posY = -241 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

-- 每2秒切换显示文本
function Lua_CollectionBookMainPanel:startTimer()
	if self.loopSwitch ~= true then
		Lua_CommonUtil.addTimer("CB_MAINPANEL_LOOPSWITCH_TXT", 2, self, self.showCollectCountTxt);
		self.loopSwitch = true;
		self:showCollectCountTxt();
	end
end

function Lua_CollectionBookMainPanel:endTimer()
	if self.loopSwitch == true then
		self.loopSwitch = false;
		Lua_CommonUtil.removeTimer(self, self.showCollectCountTxt);
	end
end

function Lua_CollectionBookMainPanel:showCollectCountTxt(isUpdateCount)
	local str;
	local curCount;
	local totalCount;
	if self.isClassicCard then
		str = LanUtil.getValue(410014);--"经典卡";
		curCount = self.classicCount;
		totalCount = self.totalClassicCount;
	else
		if isUpdateCount then
			self.switchIndex = nil;
		end
		self.switchIndex = self.switchIndex == nil and 0 or (self.switchIndex + 1) % 2;
		if self.switchIndex == 0 then
			str = LanUtil.getValue(410008);--"普卡";
			curCount = self.ordinaryCardCount;
			totalCount = self.totalOrdinaryCardCount;
		else
			str = LanUtil.getValue(410009);--"闪卡"
			curCount = self.flashCardCount;
			totalCount = self.totalFlashCardCount;
		end
	end
	self.collectCountTxt.text = LanUtil.formateStr(410010, str, curCount, totalCount);
end

function Lua_CollectionBookMainPanel:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.tabBtnInfo ~= nil then
		self.tabBtnInfo:dispose();
		self.tabBtnInfo:clear();
		self.tabBtnInfo = nil;
	end
	if self.cardItemList ~= nil then
		for k, v in pairs(self.cardItemList) do
			v:dispose();
			v = nil;
		end
		self.cardItemList = nil;
	end
	self:endTimer();
	self:superCall("dispose");
end
