--收藏册封面卡牌
Lua_CollectionBookPageCardItem = class("Lua_CollectionBookPageCardItem", Lua_ListCell);
function Lua_CollectionBookPageCardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionBookPageCardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.flashItem = Lua_CommonFlashCardItem.new(self.content);
	self.flashItem.canRotate = false; -- 是否可旋转
	self.flashItem:setSiblingIndex(0);
	self.flashItem:setCallBack(self, self.onPressClick);
end

function Lua_CollectionBookPageCardItem:updateDisplayByIndex(index, bNewCard)
	local posX, posY, scale;
	if index == 1 then
		posX, posY = -176,  248;
	elseif index == 2 then
		posX, posY =  133,  248;
	elseif index == 3 then
		posX, posY = -176, -171;
	elseif index == 4 then
		posX, posY =  133, -171;
	end
	scale = bNewCard and 0.4 or 0.52;
	self:setLocation( posX, posY);
	self.flashItem:setScale(scale, scale);
end

function Lua_CollectionBookPageCardItem:setData(data, index, bShare)
	if data == nil then
		return;
	end

	local bShow;
	local flashId;
	local isShowEffect
	self.data = data;
	self.bShare = bShare;
	self.isCompletionCard = DataCenter.collectionBookUtil:checkCompletedCard(self.data);
	if DataCenter.collectionBookUtil:getSingleCardConfigById(self.data) then
		self:setEnable(true);
		flashId = DataCenter.collectionBookUtil:getCardConfigByCardIdAndType(self.data, Lua_CollectionBookUtil.FLASH_ID);
		if flashId == nil then return; end

		local flashInfo = Lua_FlashCardVo.new(flashId);
		self:updateDisplayByIndex(index, flashInfo.showNewCard);
		self.flashItem:setData(flashInfo);

		if self.isCompletionCard then
			local isGray = not DataCenter.collectionBookData:getBActiveByCardId(self.data, Lua_CollectionBookUtil.UNLOCK_CARD, self.bShare);
			self.flashItem:setGray(isGray);

			isShowEffect = DataCenter.collectionBookUtil:checkShowEffectByCardId(self.data);

			bShow = (not self.bShare) and (not DataCenter.collectionBookUtil:checkCardTypeById(self.data, Lua_CollectionBookUtil.CLASSIC_CARD)) and
							DataCenter.collectionBookData:bShowRedPointByCardId(self.data);
		else
			self.flashItem:showNocompleteCardState(true);
			self.flashItem:setGray(false);
			self.flashItem:showEffect(false);
		end
	else
		self:setEnable(false);
	end
	self:showRedDot(bShow);
	self.flashItem:showEffect(isShowEffect, "ui_scc_sk_0002", 0, 0, 1);
end

function Lua_CollectionBookPageCardItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(112, 177);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_CollectionBookPageCardItem:onPressClick()
	if not self.isCompletionCard then
		OperateAlert.showLangValue(410033);
		return;
	end

	if self.bShare then
		Lua_WindowUtil.openWin("Lua_CollectionBookShareCardWindow", Lua_WinParam.ACTION_OPEN, {cardId = tonumber(self.data)});
	else
		Lua_WindowUtil.openWin("Lua_CollectionBookCardDetailWindow", Lua_WinParam.ACTION_OPEN, tonumber(self.data));
	end
end

function Lua_CollectionBookPageCardItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	if self.flashItem ~= nil then
		self.flashItem:dispose();
		self.flashItem = nil;
	end
	self:superCall("dispose");
end