Lua_CollectionBookShareCardWindow = class("Lua_CollectionBookShareCardWindow", Lua_Window);
function Lua_CollectionBookShareCardWindow:ctor()
	self:superCall("ctor");
	
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.windowName = "Lua_CollectionBookShareCardWindow";
	self.skinName = "CollectionBookShareCard_skin";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;

	-- self.isShowFrontPage = true;
	-- self.setImgPath = "/images/common/ui_common_window_016.png";
    -- self:addPreLoadRes(self.setImgPath, Lua_LoadFileType.IMG);
end

function Lua_CollectionBookShareCardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setLocation(-283, 563, 0);
	self.avatarItem:setScale(0.76, 0.76);
	self.avatarItem:setAvatarClick(self, self.onAvatarClick);
	self.avatarItem:setRectAnchor(4);

	self.flashItem = Lua_CommonFlashCardItem.new(self.content);
	self.flashItem:setLocation(0, 27);
	self.flashItem.openTime = 0.1;
	self.flashItem.rotateNum = 1;
	self.flashItem.canRotate = true;
end


function Lua_CollectionBookShareCardWindow:showWin(param)
	self:superCall("showWin", param);

	self.data = param.cardId;
	self.isOpenFromChat = param.isOpenFromChat;
	local flashId = DataCenter.collectionBookUtil:getCardConfigByCardIdAndType(self.data, Lua_CollectionBookUtil.FLASH_ID);
	if not DataCenter.collectionBookUtil:getSingleCardConfigById(self.data) and flashId == nil then 
		return;
	end

	local flashInfo = Lua_FlashCardVo.new(flashId);
	self:setFlashCardPos(flashInfo);
	self.flashItem:setData(flashInfo);

	local timeStr = DataCenter.collectionBookData:getUnlockTimeStr(3, self.data, true);
	self.flashItem:setGray(timeStr == nil);
	self.timeTxt.text = timeStr == nil and LanUtil.getValue(410054) or timeStr;

	local palyerInfo = DataCenter.collectionBookData:getOtherPlayerInfo();
	if palyerInfo == nil then
		self.playerNameTxt.text = "";
		return;
	end
	self.playerId = palyerInfo.id;
	self.server_flag = palyerInfo.server_flag;
	self.playerNameTxt.text = palyerInfo.name;
	self.avatarItem:setRoleDressUp(palyerInfo.dress_info);
	self.avatarItem:setRoleLevel(palyerInfo.level);

	local isShowEffect = timeStr ~= nil and DataCenter.collectionBookUtil:checkShowEffectByCardId(self.data);
	self.flashItem:setBShowEffect(isShowEffect, true, "ui_scc_sk_0001", 0, 0, 1);
end

function Lua_CollectionBookShareCardWindow:setFlashCardPos(flashInfo)
	if not flashInfo.showNewCard then
		self.flashItem:setLocation(0, 79);
		self.nameBg:setLocation(4, 513);
		self.nameBg:setAltas("collect_book_atlas", "xui_scc_widget_24");
		self.nameBg:SetDimensions(494, 95);
		self.playerNameTxt:setLocation(-116, 523);
		self.timeTxt:setLocation(64, 485);
		self.avatarItem:setLocation(-196, 514, 0);
	end
end

function Lua_CollectionBookShareCardWindow:onAvatarClick()
	if self.playerId == nil then
		return;
	end

	if DataCenter.roleData:isMyself(self.playerId) then 
		OperateAlert.showLangValue(410023);
	else
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(self.playerId, self.server_flag);
	end
end

function Lua_CollectionBookShareCardWindow:resetShareData()
	if self.isOpenFromChat then
		DataCenter.collectionBookData:setOtherPlayerInfo(nil);
		DataCenter.collectionBookData:resetOtherSingleCardData(self.data);
	end
end

function Lua_CollectionBookShareCardWindow:dispose()
	if self.flashItem ~= nil then
		self.flashItem:dispose();
		self.flashItem = nil;
	end
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	self:resetShareData();
	self:superCall("dispose");
end