-- 英雄展示闪卡窗口
checkRequire("Lua_FlashCardVo");
checkRequire("Lua_CommonFlashCardItem");
Lua_CollectionBookShowHeroChannelWindow = class("Lua_CollectionBookShowHeroChannelWindow", Lua_Window);
function Lua_CollectionBookShowHeroChannelWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_CollectionBookShowHeroChannelWindow";
	self.skinName = "CollectionBookShowHeroChannelWindow_skin";
	self.showBlackMask = true
	self.isClickClose = true;
	self.isFullSizeWin = true;
end

function Lua_CollectionBookShowHeroChannelWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.flashItem = Lua_CommonFlashCardItem.new(self.content);
	self.flashItem:setRectAnchor(1);
	self.flashItem:setLocation(0, -623);
	self.flashItem.openTime = 0.1;
	self.flashItem.rotateNum = 1;
	self.flashItem.canRotate = true;

	self.classicSp:addClickFuntion(self, self.openClassicSp);

	self:addLuaEvent("UPDATE_CBCARDDETAIL_REWARD", self, self.showReward); -- 卡牌奖励更新
end

function Lua_CollectionBookShowHeroChannelWindow:showWin(param)
	self:superCall("showWin", param);
	if type(param) ~= "table" then
		self:hide();
		return nil;
	end
	self.heroFlashCardId = nil;
	self.classicFlashCardId = nil;
	local cardlist = param;
	self.tagShowCardRedDot = true;
	if param.cardlist ~= nil then
		cardlist = param.cardlist;
		self.tagShowCardRedDot = param.tagShowCardRedDot;
	end
	local count = #cardlist;
	local curFlashId;
	local flashInfo;
	for i = 1, count do
		if self.heroFlashCardId ~= nil and self.classicFlashCardId ~= nil then
			break;
		end
		curFlashId = cardlist[i];
		flashInfo = Lua_FlashCardVo.new(curFlashId);
		if flashInfo.showNewCard and self.heroFlashCardId == nil then
			self.heroFlashCardId = curFlashId;
		end

		if not flashInfo.showNewCard and self.classicFlashCardId == nil then
			self.classicFlashCardId = curFlashId;
		end
	end

	if self.curFlashId == nil then
		self.curFlashId = self.heroFlashCardId or self.classicFlashCardId;
	end

	self.classicSp:setEnable(self.heroFlashCardId ~= nil and self.classicFlashCardId ~= nil);
	self:displayCard();
	self:showReward();
end

function Lua_CollectionBookShowHeroChannelWindow:onClickReward()
	if self.canReceivedReward then
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sReceivedReward(self.cardBagId);
	else
		DataCenter.packUtil:showItemInfo(self.itemData);
	end
end

function Lua_CollectionBookShowHeroChannelWindow:showReward()
	if self.tagShowCardRedDot ~= true then
		self.tipSp:setEnable(false);
		self.tipTxt:setEnable(false);
		return
	end
	local rewardItem;
	self.canReceivedReward, rewardItem = DataCenter.collectionBookData:getRewardStateByFlashId(self.curFlashId);
	if self.canReceivedReward then
		if rewardItem ~= nil and self.itemIcon == nil then
			self.itemData = Lua_ToolVo.createToolVo(rewardItem[1][1], rewardItem[1][2]);
			self.cardBagId = DataCenter.collectionBookUtil:getCardBagIdByFlashId(self.curFlashId);
			
			self.itemIcon = Lua_ItemIcon.new(self.content);
			self.itemIcon:setRectAnchor(1);
			self.itemIcon:setLocation(-17, -1226);
			self.itemIcon:setEnable(true);
			self.itemIcon:setClick(self, self.onClickReward);
			self.itemIcon:setData(self.itemData);
		end

		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setRectAnchor(1);
			self.redPoint:setLocation(38, -1172, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
		if self.itemIcon ~= nil then
			self.itemIcon:setEnable(false);
		end
	end
	self.tipSp:setEnable(self.canReceivedReward);
	self.tipTxt:setEnable(self.canReceivedReward);
	
end

function Lua_CollectionBookShowHeroChannelWindow:displayCard()
	local flashInfo = Lua_FlashCardVo.new(self.curFlashId);
	self.flashItem:setData(flashInfo);

	local sprite = "xui_hb_button_13"; -- 经典卡
	if self.curFlashId == self.heroFlashCardId then
		sprite = "xui_hb_button_12";
	end
	self.classicSp:setAltas("collect_book_atlas", sprite);
end

function Lua_CollectionBookShowHeroChannelWindow:openClassicSp()
	local curId = self.curFlashId == self.heroFlashCardId and self.classicFlashCardId or self.heroFlashCardId;
	self.curFlashId = curId;
	self:displayCard();
end

function Lua_CollectionBookShowHeroChannelWindow:dispose()
	if self.flashItem ~= nil then
		self.flashItem:dispose();
		self.flashItem = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end

	self:superCall("dispose");
end