checkRequire("Lua_CollectionBookTabItem");
checkRequire("Lua_CommonFlashCardItem");
Lua_CollectionWeaponWindow = class("Lua_CollectionWeaponWindow", Lua_Window);
function Lua_CollectionWeaponWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_CollectionWeaponWindow";
	self.skinName = "CollectionWeaponWindow_skin";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;
	self.showWinBg = true;
	self.winBgPath = "/images/collect_book/xui_scc_bg_1.jpg";

	self.isShareWindow = false;
    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_CollectionWeaponWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.bottomSp.mouseEnable = true;

	self.totalFlashCardCount = DataCenter.collectionBookUtil.flashCardTotalCount;
	self.totalOrdinaryCardCount = DataCenter.collectionBookUtil.ordinaryCardTotalCount;

	self.shareObj:SetActive(false);
	self:displayShareWindow();
	
	-- 分享icon的背景
	self.shareBg.clickScale = false;
	self.shareBg.clickSound = nil;
	self.shareBg:addClickFuntion(self, self.onShareBgClick);

	self.tipsIcon:addClickFuntion(self, self.onClickTipsIcon); -- 提示Icon
	self.shareIcon:addClickFuntion(self, self.onClickShowShareIcon); -- 分享显示icon
	self.worldIcon:addClickFuntion(self, self.onClickShareWorldIcon); -- 世界分享icon
	self.areaIcon:addClickFuntion(self, self.onClickShareAreaIcon); -- 频道分享icon
	self.winBg:addClickFuntion(self, self.onClickOpenCardBook); -- 打开卡册
	self.admireSp:addClickFuntion(self, self.onClickAdmireSp); -- 点赞icon
end

function Lua_CollectionWeaponWindow:showWin(param)
	self:superCall("showWin", param);
end

function Lua_CollectionWeaponWindow:displayShareWindow()
	local admireCount;
	local activityNameStr;
	local otherPlayerName;
	if self.isShareWindow then
		admireCount = DataCenter.collectionBookData.otherAdmireCount;
		local otherPlayer = DataCenter.collectionBookData:getOtherPlayerInfo();
		otherPlayerName = otherPlayer and otherPlayer.name or nil;
		self.admireSp:setEnable(true);
		self.playerNameBg:setEnable(true);
		self.tipsIcon:setEnable(false);
		self.shareIcon:setEnable(false);
		self.activityNameSp:setEnable(false);
	else
		activityNameStr = LanUtil.getValue(410002);
		self.admireSp:setEnable(false);
		self.playerNameBg:setEnable(false);
		self.tipsIcon:setEnable(true);
		self.shareIcon:setEnable(true);
		self.activityNameSp:setEnable(true);
	end
	self.admireCountTxt.text = admireCount;
	self.playerNameTxt.text = otherPlayerName;
	self.activityNameTxt.text = activityNameStr;

	self:updateCardCount();-- 卡牌数量更新 
	self:createRedPoint()
	self:startTimer();
	self:createPageCards();
	self:createBottomTabList();

	if not self.isShareWindow then
		self:addLuaEvent("UPDATE_CBWEAPON_CARDCOUNT", self, self.updateCardCount); -- 卡牌数量更新
		self:addLuaEvent("UPDATE_CBWEAPON_CARDINFO", self, self.updateCardInfo); -- 封面卡牌更新
		self:addLuaEvent("CBWEAPON_HIDESHAREOBJ", self, self.hideShareObj); -- 隐藏shareObj
	end
end

-- 创建底部页签buttonList
function Lua_CollectionWeaponWindow:createBottomTabList()
	if not self.isShareWindow then 
	    -- dragList数据
	    self.tabInfo = Array();
	    self.tabInfo:add({ tabAtlas = "collect_book_atlas_2", tabSprite = "xui_scc_zgnbutton_3_n", openWin = "Lua_CollectionBookEditWindow"});
	    self.tabInfo:add({ tabAtlas = "collect_book_atlas_2", tabSprite = "xui_scc_zgnbutton_1_n", openWin = "Lua_CollectionBookDetailWindow", tabId = 2, redPointId = Lua_RedPointList.CollectionBook_Rank});
		self.tabInfo:add({ tabAtlas = "collect_book_atlas_2", tabSprite = "xui_scc_zgnbutton_2_n", openWin = "Lua_CollectionBookDetailWindow", tabId = 3});  

	    --Lua_DragList
	    local count = self.tabInfo:getSize();
	    local width = count > 4 and 520 or count * 112;
	    self.tabList = Lua_DragList.new(self.content, width, 118, Lua_AxisDefine.Horizontal);
		self.tabList:setLocation(-width / 2, 52, 0);
		self.tabList:setRectAnchor(8);
		self.tabList.pivot = -1;
		self.tabList:setListCell(Lua_CollectionBookTabItem, 112, 118, 1);
		self.tabList:setArrayData(self.tabInfo);
	end
end

-- 创建封面卡牌
function Lua_CollectionWeaponWindow:createPageCards()
	local limitCount = DataCenter.collectionBookUtil.CBMaxCount;
	local cardlist = self.isShareWindow and DataCenter.collectionBookData.otherPageIdTab or DataCenter.collectionBookData.ownerPageIdTab;
	self.pageCardList = {};
	for i = 1, limitCount do
		self.pageCardList[i] = Lua_CollectionWeaponItem.new(self.content);
		self.pageCardList[i]:setData(cardlist[i], i, self.isShareWindow);
	end
end

-- 红点
function Lua_CollectionWeaponWindow:createRedPoint()
	if self.redPoint == nil and not self.isShareWindow then
		self.redPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.CollectionBook_MainPage);
		self.redPoint:setLocation(20, 280);
		-- self.redPoint:setRectAnchor(1);
	end
end

-- 设置封面卡牌
function Lua_CollectionWeaponWindow:updateCardInfo()
	local limitCount = DataCenter.collectionBookUtil.CBMaxCount;
	local cardlist = DataCenter.collectionBookData.ownerPageIdTab;
	for i = 1, limitCount do
		self.pageCardList[i]:setData(cardlist[i], i, self.isShareWindow);
	end
end

function Lua_CollectionWeaponWindow:onShareBgClick()
end

function Lua_CollectionWeaponWindow:onClickTipsIcon()
	self:hideShareObj();-- 隐藏shareObj
	local tipsData = { des = LanUtil.getValue(410003), posX = 174, posY = -241 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_CollectionWeaponWindow:hideShareObj()
	self.shareObj:SetActive(false);
end

--分享
function Lua_CollectionWeaponWindow:onClickShowShareIcon()
	local isShow = self.shareObj.activeSelf;
	self.shareObj:SetActive(not isShow);

	self.isOpenWorld = DataCenter.funcOpenData:isOpened(10228);
	self.worldIcon:setGray(not self.isOpenWorld);

	self.isOpenArea = DataCenter.funcOpenData:isOpened(10229);
	local isShow = DataCenter.roleData.league_id > 0 and self.isOpenArea;
	self.areaIcon:setGray(not isShow);
end

function Lua_CollectionWeaponWindow:onClickShareWorldIcon()
	if not self.isOpenWorld then
		OperateAlert.showLangValue(410004);
	else
		self:hideShareObj();-- 隐藏shareObj
		DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_COLLECTION_BOOK, true);
		Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_WORLD, "", false, false);
		OperateAlert.showLangValue(410071);
	end
end

function Lua_CollectionWeaponWindow:onClickShareAreaIcon()
	if not self.isOpenArea then
		OperateAlert.showLangValue(410004);
	elseif DataCenter.roleData.league_id <= 0 then
		OperateAlert.showLangValue(410058);
	else
		self:hideShareObj();-- 隐藏shareObj
		DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_COLLECTION_BOOK, true);
		Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_LEAGUE, "", false, false);
		OperateAlert.showLangValue(410071);
	end
end

function Lua_CollectionWeaponWindow:onClickOpenCardBook()
	self:hideShareObj();-- 隐藏shareObj
	if self.isShareWindow then
		Lua_WindowUtil.openWin("Lua_CollectionBShareBookWindow", Lua_WinParam.ACTION_OPEN, 1);
	else
		Lua_WindowUtil.openWin("Lua_CollectionBookDetailWindow", Lua_WinParam.ACTION_OPEN, 1);
	end
end


function Lua_CollectionWeaponWindow:onClickAdmireSp()
	if DataCenter.collectionBookData.residueAdmireCount <= 0 then
		OperateAlert.showLangValue(410005);
		return;
	end

	local otherPlayerInfo = DataCenter.collectionBookData:getOtherPlayerInfo();
	local playerId = otherPlayerInfo ~= nil and otherPlayerInfo.id or nil;
	local canAdmire = DataCenter.collectionBookData.canAdmireOtherPlayer;
	if not canAdmire then
		OperateAlert.showLangValue(410006);
		return;
	end

	if DataCenter.roleData:isMyself(playerId) then
		OperateAlert.showLangValue(410007);
		return;
	end
	if playerId then
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sAdmireOtherPlayer(playerId, otherPlayerInfo.server_flag);

		DataCenter.collectionBookData.otherAdmireCount = DataCenter.collectionBookData.otherAdmireCount + 1;
		DataCenter.collectionBookData.canAdmireOtherPlayer = false;
		self.admireCountTxt.text = DataCenter.collectionBookData.otherAdmireCount;
		-- self.admireSp:setAltas("common_altas_2", "ui_common_button_037_n");
	end
end

function Lua_CollectionWeaponWindow:updateCardCount()
	if self.isShareWindow then
		self.ordinaryCardCount = DataCenter.collectionBookData.otherCommonCount;
		self.flashCardCount = DataCenter.collectionBookData.otherFlashCount;
	else
		self.ordinaryCardCount = DataCenter.collectionBookData.curCommonAmount;
		self.flashCardCount = DataCenter.collectionBookData.curFlashCount;
	end
end

-- 每2秒切换显示文本
function Lua_CollectionWeaponWindow:startTimer()
	if self.loopSwitch ~= true then
		Lua_CommonUtil.addTimer("CBWIN_LOOPSWITCH_TXT", 2, self, self.showCollectCountTxt);
		self.loopSwitch = true;
		self:showCollectCountTxt();
	end
end

function Lua_CollectionWeaponWindow:endTimer()
	if self.loopSwitch == true then
		self.loopSwitch = false;
		Lua_CommonUtil.removeTimer(self, self.showCollectCountTxt);
	end
end

function Lua_CollectionWeaponWindow:showCollectCountTxt()
	local str;
	local curCount;
	local totalCount;
	self.switchIndex = self.switchIndex == nil and 0 or (self.switchIndex + 1) % 2;
	if self.switchIndex == 0 then
		str = LanUtil.getValue(410008);
		curCount = self.ordinaryCardCount;
		totalCount = self.totalOrdinaryCardCount;
	else
		str = LanUtil.getValue(410009);
		curCount = self.flashCardCount;
		totalCount = self.totalFlashCardCount;
	end
	self.collectCountTxt.text = LanUtil.formateStr(410010, str, curCount, totalCount);
end

function Lua_CollectionWeaponWindow:dispose()
	if self.tabInfo ~= nil then
		self.tabInfo:dispose();
		self.tabInfo:clear();
		self.tabInfo = nil;
	end
	if self.tabList ~= nil then
		self.tabList:dispose();
		self.tabList = nil;
	end
	if self.pageCardList ~= nil then
		for i = 1, #self.pageCardList do
			self.pageCardList[i]:dispose();
			self.pageCardList[i] = nil;
		end
		self.pageCardList = nil;
	end
	self:endTimer();
	self:superCall("dispose");
end




























--收藏册封面卡牌
Lua_CollectionWeaponItem = class("Lua_CollectionWeaponItem", Lua_DisplayObject);
function Lua_CollectionWeaponItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionWeaponItem:buildShowItem()
	self:superCall("buildShowItem");

	self.flashItem = Lua_CommonFlashCardItem.new(self.content);
	self.flashItem.canRotate = false; -- 是否可旋转
	self.flashItem:setSiblingIndex(0);
	self.flashItem:setCallBack(self, self.onPressClick);
end

function Lua_CollectionWeaponItem:updateDisplayByIndex(index, bNewCard)
	local scale, sibling;
	if index == 1 then
		sibling = 13;
		scale = bNewCard and 0.48 or 0.64;
		self:setLocation(-160, -119);
	elseif index == 2 then
		sibling = 15;
		scale = bNewCard and 0.28 or 0.38;
		self:setLocation( 145,   47);
	elseif index == 3 then
		sibling = 17;
		scale = bNewCard and 0.28 or 0.38;
		self:setLocation( 185, -260);
	end
	self.flashItem:setScale(scale, scale);
	self:setSiblingIndex(sibling);
end

function Lua_CollectionWeaponItem:setData(data, index, isShareWindow)
	if data == nil then
		return;
	end

	self.data = data;
	self.isShareWindow = isShareWindow;

	local bActive = DataCenter.collectionBookData:getBActiveByCardId(self.data, Lua_CollectionBookUtil.UNLOCK_CARD, self.isShareWindow);
	local bCompleted = DataCenter.collectionBookUtil:checkCompletedCard(self.data);
	if bActive and bCompleted then
		self:setEnable(true);
		local flashId = DataCenter.collectionBookUtil:getCardConfigByCardIdAndType(self.data, Lua_CollectionBookUtil.FLASH_ID);
		if flashId ~= nil then
			flashId = tonumber(flashId);
			local flashInfo = Lua_FlashCardVo.new(flashId);
			self.flashItem:setData(flashInfo);
			self:updateDisplayByIndex(index, flashInfo.showNewCard);

			local isShowEffect = DataCenter.collectionBookUtil:checkShowEffectByCardId(self.data);
			self:showEffect(isShowEffect);
		end
	else
		self:setEnable(false);
	end
end

function Lua_CollectionWeaponItem:showEffect(bShow)
    if bShow then
        if self.effect == nil then
            self.effect = UICreate.createUIEffect(self.flashItem.content, "/effects/uiEffects/ui_scc_sk_0002", "ui_scc_sk_0002", 0, 0);
        end
        self.effect:setEnable(true);
    else
        if self.effect ~= nil then
            self.effect:setEnable(false);
        end
    end
end

function Lua_CollectionWeaponItem:onPressClick()
	if self.isShareWindow then
		Lua_WindowUtil.openWin("Lua_CollectionBookShareCardWindow", Lua_WinParam.ACTION_OPEN, {cardId = tonumber(self.data)});
	else
		Lua_WindowUtil.openWin("Lua_CollectionBookCardDetailWindow", Lua_WinParam.ACTION_OPEN, tonumber(self.data));
	end
end

function Lua_CollectionWeaponItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	if self.flashItem ~= nil then
		self.flashItem:dispose();
		self.flashItem = nil;
	end
	if self.effect ~= nil then
		self.effect:dispose();
		self.effect = nil;
	end
	self:superCall("dispose");
end